#
#  This file is part of Documancer (http://documancer.sf.net)
#
#  Copyright (C) 2002-2003 Vaclav Slavik
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2 as
#  published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#  $Id: BusyIndicator.py,v 1.2 2003/09/06 11:29:48 vaclavslavik Exp $
#
#  Modal and modeless busy indicator (dialog and status bar)
#

from wxPython.wx import *

class BusyIndicatorDialog(wxDialog):
    def __init__(self, parent):
        wxDialog.__init__(self, parent, -1, title='Working...')
        sizer = wxBoxSizer(wxHORIZONTAL)
        self.bmp = wxStaticBitmap(self, -1,
                                  wxBitmap('data/busy_indexing.png',
                                           wxBITMAP_TYPE_ANY))
        sizer.Add(self.bmp, 0, wxALL | wxALIGN_CENTRE_VERTICAL, 10)
        self.text = wxStaticText(self, -1,
                                 'Please wait while Documancer works',
                                 size=(330,-1), style=wxALIGN_CENTRE)
        sizer.Add(self.text, 1, wxALL | wxALIGN_CENTRE_VERTICAL, 10)
        sizer.Fit(self)
        sizer.SetSizeHints(self)
        self.SetAutoLayout(1)
        self.SetSizer(sizer)
        self.Layout()
        

class BusyIndicator:
    def __init__(self, frame):
        self.frame = frame

    def show(self):
        self.dlg = BusyIndicatorDialog(self.frame)
        self.dlg.Show()
        self.dlg.Centre()
        self.disabler = wxWindowDisabler(self.dlg)
        wxSafeYield(self.dlg)

    def hide(self):
        self.disabler = None
        self.dlg.Destroy()

    def setText(self, text):
        self.dlg.text.SetLabel(text)
        wxSafeYield(self.dlg)

    def update(self):
        # FIXME - do something
        pass
